---
title: Maven
description: Maven Collector Plugin
---

import Plugin from '@site/src/components/Plugins';

Collects Maven artifacts.

<Plugin transferTag="hoppr.core_plugins.collect_maven_plugin">
{
`  maven_opts:
          - -Dhttp.proxyHost=proxy.mycompany.com
          - -Dhttp.proxyPort=80
          - -Dhttps.proxyHost=proxy.mycompany.com
          - -Dhttps.proxyPort=80
          - -Dhttp.nonProxyHosts=*.mycompany.com
`
}
</Plugin>

### Configuration Options

| Option          | Details                                                                                                                                                                                                    |
| --------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| maven_command   | String. Defaults to `mvn`. Command to be used to execute mvn commands. May be overridden with another command that uses the same syntax, or a fully qualified path if `mvn` is not on the default `$PATH`. |
| maven_opts      | Array of Strings. Additional options to be passed to the mvn command                                                                                                                                       |
| process_timeout | Number of seconds to attempt collect before timeout. **Default:** 60                                                                                                                                       |

:::note[System Dependencies]

Certain Linux distributions may require additional configuration.
See the [installation page](../../../using-hoppr/installation.md#install-maven) for more information.

:::

### Proxy and Certificate Configuration

To configure proxies, edit the `settings.xml` file for your Maven setup, as specified in [https://maven.apache.org/guides/mini/guide-proxies.html].

```xml
<settings>
    .
    .
    <proxies>
    <proxy>
        <id>example-proxy</id>
        <active>true</active>
        <protocol>http</protocol>
        <host>proxy.example.com</host>
        <port>8080</port>
        <username>proxyuser</username>
        <password>somepassword</password>
        <nonProxyHosts>www.google.com|*.example.com</nonProxyHosts>
    </proxy>
    </proxies>
    .
    .
</settings>
```

For configuring certificates for Maven, see: [https://maven.apache.org/guides/mini/guide-repository-ssl.html].

### Credentials Configuration

To specify credentials, you need a [credentials file](../../tutorials/processing-101.md#credentials).

Sample credentials file:

```yaml
---
schemaVersion: v1
kind: Credentials

metadata:
  name: Registry Credentials
  version: v1
  description: Sample credentials file

credential_required_services:
  - url: registry.gitlab.com
    user_env: CI_REGISTRY_USER
    pass_env: CI_REGISTRY_PASSWORD
```

### Experimental Maven Collector Plugin

An experimental Maven artifact collector plugin can be enabled through use of the `--experimental` or `-x` command line
option to `hopctl`, or by setting the `HOPPR_EXPERIMENTAL` environment variable to a non-empty value (typically `"1"`
by convention).

The experimental plugin does not depend on the presence of the `mvn` command line tool; it collects artifacts using web
requests to the repository endpoint(s) specified in the manifest file.

#### Configuration Options (Experimental)

There are no additional transfer file configuration options for the experimental Maven collector plugin.

#### Proxy and Certificate Configuration (Experimental)

No `settings.xml` configuration is required, but the following environment variables should be set if necessary.

| Variable                      | Details                                                                       |
| ----------------------------- | ----------------------------------------------------------------------------- |
| `HTTP_PROXY` / `http_proxy`   | Proxy server and port to use for HTTP web requests                            |
| `HTTPS_PROXY` / `https_proxy` | Proxy server and port to use for HTTPS web requests                           |
| `NO_PROXY` / `no_proxy`       | Comma-separated list of hostname patterns that should bypass the proxy server |
| `REQUESTS_CA_BUNDLE`          | Path to file containing trusted certification authority certificates          |

#### Credentials Configuration (Experimental)

Credentials are configured as outlined in [Credentials Configuration](#credentials-configuration).

### SBOM Generation Tools

- [cyclonedx-maven-plugin](https://github.com/CycloneDX/cyclonedx-maven-plugin) (plugin)

:::note
For more tools visit the [CycloneDX Tool Center](https://cyclonedx.org/tool-center/)
:::
